javax.faces.view.facelets

## Class FaceletContext

- java.lang.Object
- - javax.el.ELContext
  - - javax.faces.view.facelets.FaceletContext

-     public abstract class FaceletContext
      extends ELContext

  Context representative of a single request from a Facelet. This instance is passed to nearly every method call in this API.

  Since:
    2.0

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `FACELET_CONTEXT_KEY`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `FaceletContext()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `abstract String` | `generateUniqueId(String base)` Generate a unique ID for the passed String
    `abstract Object` | `getAttribute(String name)` Return an attribute set by a previous call to `setAttribute(java.lang.String, java.lang.Object)`.
    `abstract ExpressionFactory` | `getExpressionFactory()` The ExpressionFactory to use within the Facelet this context is executing upon.
    `abstract FacesContext` | `getFacesContext()` The current FacesContext bound to this "request".
    `abstract void` | `includeFacelet(UIComponent parent, String relativePath)` Include another Facelet defined at some path, relative to the executing context, not the current Facelet (same as include directive in JSP)
    `abstract void` | `includeFacelet(UIComponent parent, URL absolutePath)` Include another Facelet defined at some path, absolute to this ClassLoader/OS
    `abstract void` | `setAttribute(String name, Object value)` Support method which is backed by the current VariableMapper.
    `abstract void` | `setFunctionMapper(FunctionMapper fnMapper)` Set the FunctionMapper to use in EL evaluation/creation.
    `abstract void` | `setVariableMapper(VariableMapper varMapper)` Set the VariableMapper to use in EL evaluation/creation.

    - ### Methods inherited from class javax.el.ELContext

      `addEvaluationListener, convertToType, enterLambdaScope, exitLambdaScope, getContext, getELResolver, getEvaluationListeners, getFunctionMapper, getImportHandler, getLambdaArgument, getLocale, getVariableMapper, isLambdaArgument, isPropertyResolved, notifyAfterEvaluation, notifyBeforeEvaluation, notifyPropertyResolved, putContext, setLocale, setPropertyResolved, setPropertyResolved`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### FACELET_CONTEXT_KEY

          public static final String FACELET_CONTEXT_KEY

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### FaceletContext

          public FaceletContext()

  - ### Method Detail

    - #### getFacesContext

          public abstract FacesContext getFacesContext()

      The current FacesContext bound to this "request". Must not be `null`.

      Since:
        2.0

    - #### generateUniqueId

          public abstract String generateUniqueId(String base)

      Generate a unique ID for the passed String

      Parameters:
        `base` - the string from which to generate the ID.
      Since:
        2.0

    - #### getExpressionFactory

          public abstract ExpressionFactory getExpressionFactory()

      The ExpressionFactory to use within the Facelet this context is executing upon. Must not be `null`.

      Since:
        2.0

    - #### setVariableMapper

          public abstract void setVariableMapper(VariableMapper varMapper)

      Set the VariableMapper to use in EL evaluation/creation.

      Parameters:
        `varMapper` - the new `VariableMapper`
      Since:
        2.0

    - #### setFunctionMapper

          public abstract void setFunctionMapper(FunctionMapper fnMapper)

      Set the FunctionMapper to use in EL evaluation/creation.

      Parameters:
        `fnMapper` - the new `FunctionMapper`
      Since:
        2.0

    - #### setAttribute

          public abstract void setAttribute(String name,
                          Object value)

      Support method which is backed by the current VariableMapper.

      Parameters:
        `name` - the name of the attribute
        `value` - the value of the attribute
      Since:
        2.0

    - #### getAttribute

          public abstract Object getAttribute(String name)

      Return an attribute set by a previous call to `setAttribute(java.lang.String, java.lang.Object)`. Support method which is backed by the current VariableMapper

      Parameters:
        `name` - the name of the attribute to return.
      Since:
        2.0

    - #### includeFacelet

          public abstract void includeFacelet(UIComponent parent,
                            String relativePath)
                                       throws IOException

      Include another Facelet defined at some path, relative to the executing context, not the current Facelet (same as include directive in JSP)

      Parameters:
        `parent` - the `UIComponent` that will be the parent of any components in the included facelet.
        `relativePath` - the path of the resource containing the facelet markup, relative to the current markup
      Throws:
        `IOException` - if unable to load `relativePath`
        `FaceletException` - if unable to parse the markup loaded from `relativePath`
        `FacesException` - if unable to create child `UIComponent` instances
        `ELException` - if any of the expressions in the markup loaded from `relativePath` fail
      Since:
        2.0

    - #### includeFacelet

          public abstract void includeFacelet(UIComponent parent,
                            URL absolutePath)
                                       throws IOException

      Include another Facelet defined at some path, absolute to this ClassLoader/OS

      Parameters:
        `parent` - the `UIComponent` that will be the parent of any components in the included facelet.
        `absolutePath` - the absolute path to the resource containing the facelet markup
      Throws:
        `IOException` - if unable to load `relativePath`
        `FaceletException` - if unable to parse the markup loaded from `relativePath`
        `FacesException` - if unable to create child `UIComponent` instances
        `ELException` - if any of the expressions in the markup loaded from `relativePath` fail

Copyright © 1996-2013, Oracle and/or its affiliates. All Rights Reserved. Use is subject to license terms.